from dune.perftool.sumfact.quadrature import (quadrature_inames,
                                              quadrature_weight,
                                              )

from dune.perftool.sumfact.basis import (lfs_inames,
                                         pymbolic_basis,
                                         pymbolic_reference_gradient,
                                         pymbolic_trialfunction,
                                         pymbolic_trialfunction_gradient,
                                         )
import dune.perftool.sumfact.switch

from dune.perftool.pdelab import PDELabInterface


class SumFactInterface(PDELabInterface):
    def lfs_inames(self, element, restriction, number=None, context=''):
        return lfs_inames(element, restriction, number, context)

    def pymbolic_basis(self, element, restriction, number):
        return pymbolic_basis(element, restriction, number)

    def pymbolic_reference_gradient(self, element, restriction, number):
        return pymbolic_reference_gradient(element, restriction, number)

    def pymbolic_trialfunction_gradient(self, element, restriction, component, visitor=None):
        return pymbolic_trialfunction_gradient(element, restriction, component, visitor)

    def pymbolic_trialfunction(self, element, restriction, component, visitor=None):
        return pymbolic_trialfunction(element, restriction, component, visitor)

    def quadrature_inames(self):
        return quadrature_inames()

    def pymbolic_quadrature_weight(self):
        return quadrature_weight()
